#![allow(deprecated)]
use std::fmt;
use std::str;
/// Unit that the per-point time attribute is stored in.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SpatialTimeUnit {
    #[serde(rename = "NS")]
    Ns,
    #[serde(rename = "US")]
    Us,
    #[serde(rename = "MS")]
    Ms,
    #[serde(rename = "S")]
    S,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SpatialTimeUnit {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SpatialTimeUnit::Ns => "NS",
            SpatialTimeUnit::Us => "US",
            SpatialTimeUnit::Ms => "MS",
            SpatialTimeUnit::S => "S",
            SpatialTimeUnit::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SpatialTimeUnit {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SpatialTimeUnit {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SpatialTimeUnit {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SpatialTimeUnit, conjure_object::plain::ParseEnumError> {
        match v {
            "NS" => Ok(SpatialTimeUnit::Ns),
            "US" => Ok(SpatialTimeUnit::Us),
            "MS" => Ok(SpatialTimeUnit::Ms),
            "S" => Ok(SpatialTimeUnit::S),
            v => v.parse().map(|v| SpatialTimeUnit::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SpatialTimeUnit {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SpatialTimeUnit, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SpatialTimeUnit enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
